﻿//摘要：抽奖随机算法
//作者：deepleo
//博客：http://www.deepleo.com/
//邮箱：yemor@qq.com

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace RandomAlgorithm
{
    class Program
    {
        static void Main(string[] args)
        {

            var prizes = new List<Prize>();
            prizes.Add(new Prize { Name = "三等奖50%", Probability = 50 });
            prizes.Add(new Prize { Name = "二等奖40%", Probability = 40 });
            prizes.Add(new Prize { Name = "一等奖10%", Probability = 10 });
            var algo1 = new EveryRandomAlgo(prizes);
            var result1 = new Dictionary<string, int>();
            var count = 1000;//抽奖次数
            for (int i = 0; i < count; i++)
            {
                var next = algo1.Next();
               // Console.WriteLine("【{0}】算法1随机结果：{1}", i + 1, string.IsNullOrEmpty(next) ? "奖项已发完" : next);
                if (!result1.Keys.Any(x => x == next))
                {
                    result1.Add(next, 1);
                }
                else
                {
                    result1[next]++;
                }  
                Thread.Sleep(1);
            }
            foreach (var key in result1.Keys)
            {
                Console.WriteLine("算法1随最终结果：{0}:{1}个", key, result1[key].ToString());
            }
            Console.WriteLine("=====================================");
            var algo2 = new DefineByDBAlgo(prizes);
            var result2 = new Dictionary<string, int>();
            for (int i = 0; i < count; i++)
            {
                var next = algo2.Next();
                //Console.WriteLine("【{0}】算法2随机结果：{1}", i + 1, string.IsNullOrEmpty(next) ? "奖项已发完" : next);
                if (!result2.Keys.Any(x => x == next))
                {
                    result2.Add(next, 1);
                }
                else
                {
                    result2[next]++;
                }
            }
            foreach (var key in result2.Keys)
            {
                Console.WriteLine("算法2随最终结果：{0}:{1}个", key, result2[key].ToString());
            }
            Console.ReadKey();
        }

    }

}
